+++
title = "launch ftw, part 4"
date = 2023-06-22
+++

Gooooood morning! Today I'm gonna try and calculate how many sales, subscribers, visitors, etc I need to hit my financial goal for this project. The roadmap PDF says that, for a mid-range product at $49, you end up needing 28 visits and 5.6 subscribers a day, and 17 sales per month to end up making $10k in a year. I know from launching other small products that sales tend to bunch up around the public launch(es) so it's realistically more like 10k visits and 2k subscribers in a short period leading up to launch (assuming the launch is yearly and you don't then have, I dunno, end-of-year sales/promos or something.)

I messed around in [Soulver](https://soulver.app/) until my formulas got the same numbers as theirs, then adjusted the numbers for my situation and got the following:

```
goal = $8,500 + 15% (for tax) = $9,775.00

unit price = $49 = $49.00
sales needed = goal / unit price rounded up = 200
or monthly, sales needed / 12 rounded up = 17

selling to subscribers on a mailing list, so…
sale conversion = 5%
subscribe conversion = 10%

new subscribers needed = sales needed / sale conversion = 4,000
or monthly, new subscribers needed / 12 rounded up = 334
or daily, new subscribers needed / 365 = 11

new visitors needed = new subscribers needed / subscribe conversion = 40,000
or monthly, new visitors needed / 12 rounded up = 3,334
or daily, new visitors needed / 365 = 109.59
```

My first change was that I am shooting for a slightly different goal because my personal money target is $8,500 (which is very specific, yes, and also a long and annoying story.) In addition, I'd like to *actually* make that much instead of that much minus a self-employment tax haircut.

So despite having a slightly smaller goal, the end numbers there (daily subscribers/visitors needed) are higher because their formula used a 10% sale conversion (that is, mailing list to buying) and a 20% subscribe conversion (that is, hitting a blog post to subscribing.) I used 5%/10% instead because while I think their goals are stretchy but doable, I want to know the numbers I'd need if my efforts produce something half as good. I'm still a beginner at this!

This makes my bottom-line number 11 subscribers a day on average off of around 110 visitors per day. Is this realistic for me? I haven't blogged anything in a couple of months (oops) but the last thing I posted got to the front page of HN and Lobsters, which resulted in 10,366 views (as of right now.) A somewhat older but evergreen post that also made a splash resulted in 4,066 views in the same period (missing the initial spike.) If I spread those views out over a year, that's 28.4/day for the big one and 11.1/ for the evergreen one. Hmm… that's pretty far from 110/day.

That's just two posts, though. Overall, my blog has had 21,198 visits in the period I have data for. That's April 4 to June 22 (79 days), which means my blog got 268 visits per day. If I subtract the article that got on HN and the other one it referenced, I'm left with 188.6 visits per day. Both of those are bigger than the target of 110 by a comfortable margin!

So, OK, I think I've convinced myself that 110 visitors a day is a reasonable target. The roadmap mentions making a freebie available to subscribers, which tends to bring the subscribe conversion up (and therefore the needed visitors down.) I don't have data from my older launch to look at sale conversion, but the top of the funnel seems reasonable so I feel OK with proceeding.

Tomorrow I'll proceed with lesson four in the guidebook. This diversion took all the time I had for this project today, but I'm glad I did it!

---

Update later in the day... I forgot about fees!

```
goal = $8,500 + 15% (for tax) = $9,775.00

unit price = $49 = $49.00
net profit = unit price − 10% for fees = $44.10
sales needed = goal / net profit rounded up = 222
or monthly, sales needed / 12 rounded up = 19

selling to subscribers on a mailing list, so…
sale conversion = 5%
subscribe conversion = 10%

new subscribers needed = sales needed / sale conversion = 4,440
or monthly, new subscribers needed / 12 rounded up = 370
or daily, new subscribers needed / 365 = 12.2

new visitors needed = new subscribers needed / subscribe conversion = 44,400
or monthly, new visitors needed / 12 rounded up = 3,700
or daily, new visitors needed / 365 = 121.64
```

OK, 122 visits a day needed instead of 110. Doable. And that's assuming I use Gumroad, which has ri-di-cu-lous fees of 10%.
