+++
title = "Learning Requires Effort"
date = 2021-01-05
+++

I recently finished [*How to Take Smart Notes*](https://takesmartnotes.com).
The core idea I took away from the book is that *learning requires effort*.

## Two Kinds of Effort

I think people generally recognize that learning requires effort, but have an easier time applying that to physical activities than mental ones.
You don't really go around assuming that Olympic athletes are just people who jumped out of bed the morning of the games and decided to win gold in ice dancing.
Instead, we recognize that athletes train hard for many years in order to reach the top of the field.

But when it comes to learning in more abstract ways, it's somehow easier to forget that effort is necessary!
For example, I've made the mistake many times of assuming I learned something just because I reached the last page of a book.

With that in mind, I can think of at least two ways of putting in the effort to learn.
There are definitely more, though!

*How to Take Smart Notes* recommends using the Zettelkasten (slip-box) system [covered](https://zettelkasten.de/posts/overview/) [many](https://www.fastcompany.com/90535318/this-simple-but-powerful-analog-method-will-rocket-your-productivity) [places](https://writingcooperative.com/zettelkasten-how-one-german-scholar-was-so-freakishly-productive-997e4e0ca125) this past summer.
In this method, "effort" looks like making notes by rephrasing and making connections to things you already know.
Educationally speaking, this is called elaboration.

Outside of note-taking, I see this in how programmers learn new tools and techniques.
When someone says they want to learn something, a common response goes "well, make a small but useful project and see."
I've told people that many times myself without recognizing that I'm telling people to learn through effort.

These examples make "learning requires effort" seem pretty general to me, since it applies both in places I expected and places I didn't.
That has the feel of a useful principle which I can use to judge if I'm learning or not!
Am I putting in effort?
If not, I'm probably not learning!

## Someone Else Can't Learn For You

"Learning requires effort" also means that someone else can't learn for you.
Think about it: if learning requires effort, and someone else is putting in the effort, then it's not *you* doing the learning.
That's another mistake I've made many times over the years!
It's natural for me to try and find the perfect resource when what I actually need to just get into the work of effortful learning as quickly as I can.

I've seen this show up in several ways.
The first is conflating building a collection with learning.
Where's the learning effort in just collecting information from other people, whether papers, conference talks, or blog posts?
If you're not putting in the effort to connect new stuff to what you already know, you're just playing gotta-catch-em-all with PDFs!

The second is similar, but a little more specific: using other people's flashcards.
I've seen quite a few places where you can download flashcard decks for various computer science concepts.
At first glace, that seems fine, but where's the learning there?
It's certainly a lot of *effort* to memorize a flashcard deck by rote, but it's the kind of effort that makes you learn the deck, not the subject.
Making flashcards, on the other hand, can actually create connections as you think about how best to structure the subject in flashcard form.

## Put It All Together

So, if learning requires effort, how can we learn?
Simple: just put in the effort.

But, oops, it's actually not so simple: *what* effort?
What's right for you and for what you're learning?
If you just thrash and flail, by trying things that are way beyond your current skill or level of understanding, you won't actually learn much.
To be effective, the things you're trying to learn have to be just beyond what you can do already (in the [zone of proximal development](https://en.wikipedia.org/wiki/Zone_of_proximal_development).)

You also have to make sure you're learning in a way that you can actually apply your new knowledge.
That means working towards some level or standard of mastery, ideally one against which you can measure your progress.
(For example, being able to clear the bar at a certain level in the high jump.)

That's what a good teacher, mentor, or coach is for: someone who has helped other people learn the thing you're trying to learn can give you good advice on the best places to apply your effort as well as a standard of mastery to grow towards.
